IMPLEMENTATION MODULE Mtxs;

IMPORT WinBase;
FROM Heap IMPORT ALLOCATE, DEALLOCATE;

TYPE
  TMtx = POINTER TO TMutexDesc;
  TMutexDesc = WinBase.CRITICAL_SECTION;


PROCEDURE New(): TMtx;
VAR
  m: TMtx;
BEGIN
  NEW( m );
  WinBase.InitializeCriticalSection( m^ );
  RETURN m;
END New;

PROCEDURE Req( m: TMtx );
BEGIN
  WinBase.EnterCriticalSection( m^ );
END Req;

PROCEDURE Rel( m: TMtx );
BEGIN
  WinBase.LeaveCriticalSection( m^ );
END Rel;

PROCEDURE Try( m: TMtx ): BOOLEAN;
BEGIN
  RETURN WinBase.TryEnterCriticalSection( m^ );
END Try;

END Mtxs.
